:_newdoc-version: 2.16.0
:_template-generated: 2024-03-26

:_mod-docs-content-type: REFERENCE

[id="debugging-applications-in-containers_{context}"]
= Debugging applications in containers

[role="_abstract"]
You can use various command-line tools tailored to different aspects of troubleshooting. The following provides categories along with common command-line tools.

[NOTE]
====
This is not a complete list of command-line tools. The choice of tool for debugging a container application  is heavily based on the container image and your use case.

For instance, the `systemctl`, `journalctl`, `ip`, `netstat`, `ping`, `traceroute`, `perf`, `iostat` tools may need root access because they interact with system-level resources such as networking, systemd services, or hardware performance counters, which are restricted in rootless containers for security reasons. 
====

Rootless containers operate without requiring elevated privileges, running as non-root users within user namespaces to provide improved security and isolation from the host system. They offer limited interaction with the host, reduced attack surface, and enhanced security by mitigating the risk of privilege escalation vulnerabilities.

Rootful containers run with elevated privileges, typically as the root user, granting full access to system resources and capabilities. While rootful containers offer greater flexibility and control, they pose security risks due to their potential for privilege escalation and exposure of the host system to vulnerabilities.

For more information about rootful and rootless containers, see link:https://access.redhat.com/documentation/en-us/red_hat_enterprise_linux/{ProductNumberLink}/html-single/building_running_and_managing_containers/index#proc_setting-up-rootless-containers_assembly_starting-with-containers[Setting up rootless containers], link:https://access.redhat.com/documentation/en-us/red_hat_enterprise_linux/{ProductNumberLink}/html-single/building_running_and_managing_containers/index#proc_upgrading-to-rootless-containers_assembly_starting-with-containers[Upgrading to rootless containers], and link:https://access.redhat.com/documentation/en-us/red_hat_enterprise_linux/{ProductNumberLink}/html-single/building_running_and_managing_containers/index#con_special-considerations-for-rootless-containers_assembly_starting-with-containers[Special considerations for rootless containers].

.Systemd and Process Management Tools

`systemctl`:: Controls systemd services within containers, allowing start, stop, enable, and disable operations.
`journalctl`:: Views logs generated by systemd services, aiding in troubleshooting container issues.

.Networking Tools

`ip`:: Manages network interfaces, routing, and addresses within containers.
`netstat`:: Displays network connections, routing tables, and interface statistics.
`ping`:: Verifies network connectivity between containers or hosts.
`traceroute`:: Identifies the path packets take to reach a destination, useful for diagnosing network issues.

.Process and Performance Tools

`ps`:: Lists currently running processes within containers.
`top`:: Provides real-time insights into resource usage by processes within containers.
`htop`:: Interactive process viewer for monitoring resource utilization.
`perf`:: CPU performance profiling, tracing, and monitoring, aiding in pinpointing performance bottlenecks within the system or applications.
`vmstat`:: Reports virtual memory statistics within containers, aiding in performance analysis.
`iostat`:: Monitors input/output statistics for block devices within containers.
`gdb` (GNU Debugger):: A command-line debugger that helps in examining and debugging programs by allowing users to track and control their execution, inspect variables, and analyze memory and registers during runtime. 
For more information, see the link:https://developers.redhat.com/blog/2020/01/09/debugging-applications-within-red-hat-openshift-containers[Debugging applications within Red Hat OpenShift containers] article. 
`strace`:: Intercepts and records system calls made by a program, aiding in troubleshooting by revealing interactions between the program and the operating system.

.Security and Access Control Tools

`sudo`:: Enables executing commands with elevated privileges.
`chroot`:: Changes the root directory for a command, helpful in testing or troubleshooting within a different root directory.

.Podman-Specific Tools

`podman logs`:: Batch-retrieves whatever logs are present for one or more containers at the time of execution.
`podman inspect`:: Displays the low-level information on containers and images as identified by name or ID.
`podman events`:: Monitor and print events that occur in Podman. Each event includes a timestamp, a type, a status, a name (if applicable), and an image (if applicable). The default logging mechanism is `journald`.
`podman run --health-cmd`:: Use the health check to determine the health or readiness of the process running inside the container.
`podman top`:: Display the running processes of the container. 
`podman exec`:: Running commands in or attaching to a running container is extremely useful to get a better understanding of what is happening in the container.
`podman export`:: When the container fails, it is basically impossible to know what happened. Exporting the filesystem structure from the container will allow for checking other logs files that may not be in the mounted volumes.

[role="_additional-resources"]
.Additional resources
* link:https://developers.redhat.com/blog/2020/01/09/debugging-applications-within-red-hat-openshift-containers[Debugging applications within Red Hat OpenShift containers]
** `gdb`
* link:https://access.redhat.com/documentation/en-us/red_hat_enterprise_linux/7/html/developer_guide/debugging-crashed-application[Debugging a Crashed Application]
** Core dump, `sosreport`, `gdb`, `ps`, `core`.
* link:https://access.redhat.com/documentation/en-us/red_hat_enterprise_linux_atomic_host/7/html/getting_started_with_kubernetes/troubleshooting_kubernetes[Troubleshooting Kubernetes]
** Docker exec + env, `netstat`, `kubectl`, `etcdctl`, `journalctl`, docker logs
* link:https://docs.openstack.org/project-deploy-guide/tripleo-docs/latest/deployment/tips_tricks.html[Tips and Tricks for containerizing services]
** Watch, `podman logs`, `systemctl`, `podman exec`/`kill`/`restart`, `podman insect`, `podman top`, `podman exec`, `podman export`, `paunch`
* External links
** link:https://medium.com/@betz.mark/ten-tips-for-debugging-docker-containers-cde4da841a1d[Ten tips for debugging Docker containers]
